<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/16/2004 *
 * ===============                              Last change: 10/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : user_functions.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for user extension             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktionen fuer die user-Erweiterung   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Add links for selecting some users
function alpha ($sortby, $colspan, $return=false) {
	if (!isGetRequestElementSet('offset')) setRequestGetElement('offset', 0);
	$add = "&amp;page=".getRequestElement('page')."&amp;offset=".getRequestElement('offset');
	if (isGetRequestElementSet('mode')) $add .= "&amp;mode=".getRequestElement('mode');

	/* Creates the list of letters and makes them a link. */
	$alphabet = explode(',', getMessage('_ALL2') . ',A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z,' . getMessage('_OTHERS'));
	$num = count($alphabet) - 1;
	$OUT = '';
	while (list($counter, $ltr) = each($alphabet)) {
		if (getRequestElement('letter') == $ltr) {
			// Current letter is letter from URL
			$OUT .= "<strong>".$ltr."</strong>";
		} else {
			// Output link to letter
			$OUT .= "<a href=\"{?URL?}/modules.php?module=admin&amp;what=".getWhat();
			if (isGetRequestElementSet('mode')) $OUT .= "&amp;mode=".getRequestElement('mode');
			$OUT .= "&amp;letter=".$ltr."&amp;sortby=".$sortby.$add."\">".$ltr."</a>";
		}

		if ((($counter / getConfig('user_alpha')) == round($counter / getConfig('user_alpha'))) && ($counter > 0)) {
			$OUT .= "&nbsp;]<br />[&nbsp;";
		} elseif ( $counter != $num ) {
			$OUT .= "&nbsp;|&nbsp;";
		}
	} // END - while

	// Load template
	$OUT = loadTemplate('admin_list_user_alpha', true, $OUT);
	if ($return === true) {
		// Return generated code
		return $OUT;
	} else {
		// Output generated code
		outputHtml($OUT);
	}
}

// Add links for sorting
function addSortLinks ($letter, $sortby, $colspan, $return=false) {
	$OUT = '';
	if (!isGetRequestElementSet('offset')) setRequestGetElement('offset', 0);
	if (!isGetRequestElementSet('page'))   setRequestGetElement('page'  , 0);

	// Add page and offset
	$add = '&amp;page=' . getRequestElement('page') . '&amp;offset=' . getRequestElement('offset');

	// Add status or mode
	if (isGetRequestElementSet('status'))   $add .= '&amp;mode=' . getRequestElement('status');
	elseif (isGetRequestElementSet('mode')) $add .= '&amp;mode=' . getRequestElement('mode');

	// Makes order by links..
	if ($letter == 'front') $letter = getMessage('_ALL2');

	// Prepare array with all possible sorters
	$list = array(
		'userid'      => getMessage('_UID'),
		'family'      => getMessage('FAMILY_NAME'),
		'email'       => getMessage('EMAIL_ADDRESS'),
		'REMOTE_ADDR' => getMessage('REMOTE_IP')
	);

	// Add nickname if extension is installed
	if (isExtensionActive('nickname')) {
		$list['nickname'] = getMessage('NICKNAME');
	} // END - if

	foreach ($list as $sort => $title) {
		if ($sortby == $sort) {
			$OUT .= "<strong>" . $title . "</strong>&nbsp;|&nbsp;";
		} else {
			$OUT .= "<a href=\"{?URL?}/modules.php?module=admin&amp;what=list_user&amp;letter=" . $letter . "&amp;sortby=" . $sort.$add . "\">" . $title . "</a>&nbsp;|&nbsp;";
		}
	} // END - foreach

	$content['list'] = substr($OUT, 0, -13);

	// Load template
	$OUT = loadTemplate('admin_list_user_sort', true, $content);

	// Should we return or output?
	if ($return === true) {
		// Return code
		return $OUT;
	} else {
		// Output code
		outputHtml($OUT);
	}
}

// Add page navigation
function addPageNavigation ($PAGES, $offset, $show_form, $colspan,$return=false) {
	// @TODO These two constants are no longer used, maybe we reactivate this code?
	//if ($show_form === true) {
	//	// Load form for changing number of lines
	//	define('__FORM_HEADER', loadTemplate('admin_list_user_sort_form', true));
	//	define('__FORM_FOOTER', '<tr><td colspan="'.$colspan.'" class="seperator bottom2">&nbsp;</td></tr>');
	//} else {
	//	// Empty row
	//	define('__FORM_HEADER', '<tr><td colspan="' . $colspan . '" class="seperator">&nbsp;</td></tr>');
	//	define('__FORM_FOOTER', '<tr><td colspan="' . $colspan . '" class="seperator bottom2">&nbsp;</td></tr>');
	//}

	$OUT = '';
	for ($page = 1; $page <= $PAGES; $page++) {
		if (($page == getRequestElement('page')) || ((!isGetRequestElementSet('page')) && ($page == 1))) {
			$OUT .= '<strong>-';
		} else {
			if (!isGetRequestElementSet('letter')) setRequestGetElement('letter', getMessage('_ALL2'));
			if (!isGetRequestElementSet('sortby')) setRequestGetElement('sortby', 'userid');

			// Base link
			$OUT .= '<a href="{?URL?}/modules.php?module=admin&amp;what=' . getWhat();

			// Add status or mode
			if (isGetRequestElementSet('status'))    $OUT .= '&amp;mode=' . getRequestElement('status');
			 elseif (isGetRequestElementSet('mode')) $OUT .= '&amp;mode=' . getRequestElement('mode');

			// Letter and so on
			$OUT .= '&amp;letter=' . getRequestElement('letter') . '&amp;sortby=' . getRequestElement('sortby') . '&amp;page=' . $page . '&amp;offset=' . $offset . '">';
		}

		$OUT .= $page;

		if (($page == getRequestElement('page')) || ((!isGetRequestElementSet('page')) && ($page == 1))) {
			$OUT .= '-</strong>';
		} else 	{
			$OUT .= '</a>';
		}

		if ($page < $PAGES) $OUT .= '&nbsp;|&nbsp;';
	} // END - for

	// Remember the list
	$content['list'] = $OUT;

	// Load template
	$OUT = loadTemplate('admin_list_user_pagenav', true, $content);
	if ($return === true) {
		// Return code
		return $OUT;
	} else {
		// Output code
		outputHtml($OUT);
	}
}

// Create email link to user's account
function generateUserEmailLink($email, $mod = 'admin') {
	// Show contact link only if user is confirmed by default
	$locked = " AND `status`='CONFIRMED'";

	// But admins shall always see it
	if (isAdmin()) $locked = '';

	$result = SQL_QUERY_ESC("SELECT
	`userid`
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	`email`='%s'" . $locked."
LIMIT 1",
		array($email), __FUNCTION__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Load userid
		list($userid) = SQL_FETCHROW($result);

		// Rewrite email address to contact link
		$email = '{?URL?}/modules.php?module=' . $mod . '&amp;what=user_contct&amp;userid=' . bigintval($userid);
	} // END - if

	// Free memory
	SQL_FREERESULT($result);

	// Return rewritten (?) email address
	return $email;
}

// Selects a random user id as the new referal id if they have at least X confirmed mails in this run
function determineRandomReferalId () {
	// Default is zero refid
	$refid = 0;

	// Is the extension version fine?
	if (getExtensionVersion('user') >= '0.3.4') {
		// Get all user ids
		$totalUsers = countSumTotalData('CONFIRMED', 'user_data', 'userid', 'status', true, " AND `rand_confirmed` >= ".getConfig('user_min_confirmed')."");

		// Do we have at least one?
		if ($totalUsers > 0) {
			// Then choose random number
			$randNum = mt_rand(0, ($totalUsers - 1));

			// Look for random user
			$result = SQL_QUERY_ESC("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `status`='CONFIRMED' AND `rand_confirmed` >= {?user_min_confirmed?} ORDER BY `rand_confirmed` DESC LIMIT %s, 1",
				array($randNum), __FUNCTION__, __LINE__);

			// Do we have one entry there?
			if (SQL_NUMROWS($result) == 1) {
				// Use that userid as new referal id
				list($refid) = SQL_FETCHROW($result);

				// Reset this user's counter
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `rand_confirmed`=0 WHERE `userid`=%s LIMIT 1",
					array($refid), __FUNCTION__, __LINE__);
			} // END - if

			// Free result
			SQL_FREERESULT($result);
		} // END - if
	} // END - if

	// Return result
	return $refid;
}

// Do the user login
function doUserLogin ($userid, $passwd, $successUrl = '', $errorUrl = 'modules.php?module=index&amp;what=login&amp;login=') {
	// Init variables
	$dmy = '';
	$add = '';
	$errorCode = 0;

	// Add last_login if available
	$lastOnline = '';
	if (getExtensionVersion('sql_patches') >= '0.2.8') {
		$lastOnline = ', `last_login`';
	} // END - if

	// Init array
	$content = array(
		'password'    => '',
		'userid'      => '',
		'last_online' => 0,
		'last_login'  => 0,
		'hash'        => ''
	);

	// Check login data
	if ((isExtensionActive('nickname')) && (isNicknameOrUserid($userid))) {
		// Nickname entered
		fetchUserData($userid, 'nickname');
	} else {
		// Direct userid entered
		fetchUserData($userid);
	}

	// Load entry
	$content = getUserDataArray();
	if (!empty($content['userid'])) $userid = bigintval($content['userid']);

	// Is there an entry?
	if ((isUserDataValid()) && (getUserData('status') == 'CONFIRMED') && ((isNicknameUsed($content['userid'] === true) && (!empty($content['userid']))) || ($content['userid'] == $userid))) {
		// Check for old MD5 passwords
		if ((strlen($content['password']) == 32) && (md5($passwd) == $content['password'])) {
			// Just set the hash to the password from DB... :)
			$content['hash'] = $content['password'];
		} else {
			// Hash password with improved way for comparsion
			$content['hash'] = generateHash($passwd, substr($content['password'], 0, -40));
		}

		// Does the password match the hash?
		if ($content['hash'] == $content['password']) {
			// New hashed password found so let's generate a new one
			$content['hash'] = generateHash($passwd);

			// ... and update database
			// @TODO Make this filter working: $ADDON = runFilterChain('post_login_update', $content);
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `password`='%s' WHERE `userid`=%s AND `status`='CONFIRMED' LIMIT 1",
				array($content['hash'], $userid), __FUNCTION__, __LINE__);

			// No login bonus by default
			$GLOBALS['bonus_payed'] = false;

			// Probe for last online timemark
			$probe = time() -  $content['last_online'];
			if (!empty($content['last_login'])) $probe = time() - $content['last_login'];
			if ((getExtensionVersion('bonus') >= '0.2.2') && ($probe >= getConfig('login_timeout'))) {
				// Add login bonus to user's account
				$add = ', `login_bonus`=`login_bonus`+{?login_bonus?}';
				$GLOBALS['bonus_payed'] = true;

				// Subtract login bonus from userid's account or jackpot
				if ((getExtensionVersion('bonus') >= '0.3.5') && (getConfig('bonus_mode') != 'ADD')) handleBonusPoints('login_bonus');
			} // END - if

			// Calculate new hash with the secret key and master salt together
			$content['hash'] = generatePassString($content['hash']);

			// Update global array
			// @TODO Make this filter working: $URL = runFilterChain('do_login', array('content' => $content, 'addon' => $ADDON));
			setMemberId($userid);

			// Try to set session data (which shall normally always work!)
			if ((setSession('userid', $userid )) && (setSession('u_hash', $content['hash']))) {
				// Update database records
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `total_logins`=`total_logins`+1" . $add . " WHERE `userid`=%s LIMIT 1",
					array($userid), __FUNCTION__, __LINE__);
				if (SQL_AFFECTEDROWS() == 1) {
					// Is a success URL set?
					if (empty($successUrl)) {
						// Procedure to checking for login data
						if (($GLOBALS['bonus_payed']) && (isExtensionActive('bonus'))) {
							// Bonus added (just displaying!)
							$URL = 'modules.php?module=chk_login&amp;mode=bonus';
						} else {
							// Bonus not added
							$URL = 'modules.php?module=chk_login&amp;mode=login';
						}
					} else {
						// Use this URL
						$URL = $successUrl;
					}
				} else {
					// Cannot update counter!
					$errorCode = getCode('CNTR_FAILED');
				}
			} else {
				// Cookies not setable!
				$errorCode = getCode('NO_COOKIES');
			}
		} elseif (getExtensionVersion('sql_patches') >= '0.6.1') {
			// Update failture counter
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `login_failures`=`login_failures`+1,`last_failure`=NOW() WHERE `userid`=%s LIMIT 1",
				array($userid), __FUNCTION__, __LINE__);

			// Wrong password!
			$errorCode = getCode('WRONG_PASS');
		}
	} elseif (((isNicknameUsed($content['userid'])) && (!empty($content['userid']))) || ($content['userid'] == $userid)) {
		// Other account status?
		if (fetchUserData($userid)) {
			// Create an error code from given status
			$errorCode = generateErrorCodeFromUserStatus(getUserData('status'));
		} else {
			// id not found!
			$errorCode = getCode('WRONG_ID');
		}
	} else {
		// id not found!
		$errorCode = getCode('WRONG_ID');
	}

	// Error code provided?
	if ($errorCode > 0) {
		// Then reconstruct the URL
		$URL = $errorUrl . $errorCode;
	} // END - if

	// Return URL
	return $URL;
}

// Try to send a new password for the given user account
function doNewUserPassword ($email, $userid) {
	// Compile email when found in address (only secure chars!)
	if (!empty($email)) $email = str_replace('{DOT}', '.', $email);

	// Init result and error
	$errorCode = '';
	$result = false;

	// Probe userid/nickname
	// @TODO We should try to rewrite this to fetchUserData() somehow
	if ((isExtensionActive('nickname')) && (isNicknameOrUserid($userid))) {
		// Nickname entered
		$result = SQL_QUERY_ESC("SELECT `userid`, `status` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `nickname`='%s' OR `userid`='%s' OR `email`='%s' LIMIT 1",
			array($userid, $userid, $email), __FUNCTION__, __LINE__);
	} elseif (($userid > 0) && (empty($email))) {
		// Direct userid entered
		$result = SQL_QUERY_ESC("SELECT `userid`, `status` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
			array(bigintval($userid)), __FUNCTION__, __LINE__);
	} elseif (!empty($email)) {
		// Email entered
		$result = SQL_QUERY_ESC("SELECT `userid`, `status` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `email`='%s' LIMIT 1",
			array($email), __FUNCTION__, __LINE__);
	} else {
		// Userid not set!
		logDebugMessage(__FUNCTION__, __LINE__, 'Userid is not set! BUG!');
		$errorCode = getCode('WRONG_ID');
	}

	// Any entry found?
	if (SQL_NUMROWS($result) == 1) {
		// This data is valid, so we create a new pass... :-)
		list($userid, $status) = SQL_FETCHROW($result);

		if ($status == 'CONFIRMED') {
			// Ooppps, this was missing! ;-) We should update the database...
			$NEW_PASS = generatePassword();
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `password`='%s' WHERE `userid`=%s LIMIT 1",
				array(generateHash($NEW_PASS), $userid), __FUNCTION__, __LINE__);

			// Prepare data and message for email
			$message = loadEmailTemplate('new-pass', array('new_pass' => $NEW_PASS, 'nickname' => $userid), $userid);

			// ... and send it away
			sendEmail($userid, getMessage('GUEST_NEW_PASSWORD'), $message);

			// Output note to user
			loadTemplate('admin_settings_saved', false, getMessage('GUEST_NEW_PASSWORD_SEND'));
		} else {
			// Account is locked or unconfirmed
			$errorCode = generateErrorCodeFromUserStatus($status);

			// Load URL
			redirectToUrl('modules.php?module=index&amp;what=login&amp;login='.$errorCode);
		}
	} else {
		// id or email is wrong
		loadTemplate('admin_settings_saved', false, '<span class="guest_failed">{--GUEST_WRONG_ID_EMAIL--}</span>');
	}

	// Return the error code
	return $errorCode;
}

// [EOF]
?>
